# recipe
## Time_aggregation$execute YES/NO
## Time_aggregation$method accumulated or average
## Time_aggregation$set for decadal
## Time_aggregation$ini based on forecast time
## Time_aggregation$end based on forecast time
## ini = 2, end = 3 with monthly freq would be a 2 months agg
Aggregation(recipe, data) {

  ncores <- recipe$Analysis$ncores # is it already checked? NULL or number
  na.rm <- recipe$Analysis$remove_NAs # is it already checked? TRUE/FALSE
  if (recipe$Analysis$Workflow$Time_aggregation$execute) {
    # original freq
    raw_freq <- tolower(recipe$Analysis$Variable$freq)
    custom <- recipe$Analysis$Workflow$Time_aggregation$set
    ini <- recipe$Analysis$Workflow$Time_aggregation$ini
    end <- recipe$Analysis$Workflow$Time_aggregation$end
    method <- tolower(recipe$Analysis$Workflow$Time_aggregation$method)
## Instead of raw freq may be better to use ini/end
##    if (raw_freq %in% c('daily', 'daily_mean', 'weekly', 'weekly_mean')) {
    if (!is.null(ini) && !is.null(end)) {
      # calculate aggregations from fday1 to fday2
      # calculate aggregations from fweek1 to fweek2
      # other cases could be indicators or other original freq
      res <- sapply(1:length(data), function(x) {
                    if (!is.null(data[[x]])) {
                      result <- agg_ini_end(data[x], method = method,
                                            na.rm = na.rm, ncores = ncores,
                                            ini = ini, end = end)
                    } else {
                      result <- data[x]
                    }}, simplify = TRUE)
                   
    } else if (!is.null(custom)) {
      # caluclate aggreagtions from fmonth1 to ftmonth2
      # for decadal, it makes sense to get all seasons and annual means too

    } else {
      # higher frequencies are typically used to compute indicators
      # lower frequencies are not typically stored in esarchive
    }
  }
}

agg_ini_end <- function(x, ini, end, method, na.rm , ncores) {
  if (method == 'average') { 
    x[[1]]$data <- Apply(x[[1]]$data, target_dim = 'time',
                                    function(y) {
                                    mean(y[ini:end], na.rm = na.rm)},
                                    ncores = ncores)
  } else if (method == 'accumulated') {
    x[[1]]$data <- Apply(x[[1]]$data, target_dim = 'time',
                                    function(y) {
                                    sum(y[ini:end], na.rm = na.rm)},
                                    ncores = ncores)
  } else {
    stop("Unknown method")
  } 
  dims <- x[[1]]$dims
  dims['time'] <- length(ini:end)
  x[[1]]$dims <- dims
  x[[1]]$coords$time <- ini:end
  attr(x[[1]]$coords$time, "indices") <- TRUE 
  x[[1]]$attrs$Dates <- Subset(x[[1]]$attrs$Dates, along = 'time',
                               indices = ini:end)
  return(x)
}
